/*
 *
 * Copyright (C) 2003 Sadysta ( http://sadysta.ath.cx )
 * Copyright (C) 2007 Tomasz Ostrowski ( http://ostry.w.szu.pl ) - modified from 1.8.9 source
 *
 * This file is part of Free GG.
 *
 * Free GG is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Free GG is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Free GG; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "ChPwd.h"
#include "GaduThread.h"
#include "GGToken.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TChPwdForm *ChPwdForm = NULL;
//---------------------------------------------------------------------------
__fastcall TChPwdForm::TChPwdForm(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
/** \todo przetestowa - jaki problem wystpi przy pierwszej prbie,
serwer zacz rozcza usera po zmianie hasa */
void __fastcall TChPwdForm::Button1Click(TObject *Sender)
{
        AnsiString tokenid, tokenval;

        GGTokenForm -> Edit1 -> Text = "";
        TokenProc (tokenid);
        if (GGTokenForm -> ShowModal() != mrOk) return;
        tokenval = GGTokenForm -> Edit1 -> Text;

        TClientSocket *S;
        TWinSocketStream *SS;
        AnsiString Request, Content, Reply;
        char buf[100];
        int count;

        S = new TClientSocket(NULL);
        S -> ClientType = ctBlocking;
        S -> Host = "register.gadu-gadu.pl";
        S -> Port = 80;
        S -> Open();

        Content = "fmnumber=" + Edit1 -> Text + "&fmpwd=" + Edit2 -> Text + "&pwd=" + Edit3 -> Text + "&email=" + Edit5 -> Text + "&tokenid=" + tokenid + "&tokenval=" + tokenval + "&code=" + IntToStr(gg_http_hash ("ss", Edit5 -> Text.c_str(), Edit3 -> Text.c_str()));

		Request = "POST /appsvc/fmregister3.asp HTTP/1.0\r\n\
Host: register.gadu-gadu.pl\r\n\
Content-Type: application/x-www-form-urlencoded\r\n\
User-Agent: Mozilla/4.0 (compatible; MSIE 5.0; Windows 98)\r\n\
Content-Length: " + IntToStr(Content.Length() + 1) + "\r\n\
Pragma: no-cache\r\n\r\n" + Content;

        SS = new TWinSocketStream (S -> Socket, 10000);

//        ShowMessage (Request);

        SS -> Write (Request.c_str(), Request.Length()+1);

        Reply = "";
        while ( (count = SS -> Read (buf, sizeof(buf))) > 0 ) Reply += ((AnsiString)buf).SubString(1,count);

        delete SS;
        S -> Close();
        delete S;

//        ShowMessage (Reply);
//        int start = Reply.Pos("reg_success:") + 12;
        if (Reply.Pos ("reg_success") != 0)
        /** \todo Uaktualni ustawienia po zmianie hasa dla konta gg */
				ShowMessage ("Haso zostao zmienione.");
		else
                ShowMessage ("Wystapi bd - haso nie zostao zmienione. Komunikat:\n" + Reply);
}
//---------------------------------------------------------------------------
