/*
 *
 * Copyright (C) 2003 Sadysta ( http://sadysta.ath.cx )
 * Copyright (C) 2007 Tomasz Ostrowski ( http://ostry.w.szu.pl ) - modified from 1.8.9 source
 *
 * This file is part of Free GG.
 *
 * Free GG is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Free GG is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Free GG; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

//---------------------------------------------------------------------------

#ifndef ContactH
#define ContactH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <stdio.h>
//---------------------------------------------------------------------------
class TContactForm : public TForm
{
__published:	// IDE-managed Components
        TButton *Button1;
        TButton *Button2;
        TButton *Button3;
        TLabel *Label1;
        TEdit *firstname;
        TEdit *lastname;
        TLabel *Label2;
        TEdit *nickname;
        TLabel *Label3;
        TEdit *display;
        TLabel *Label4;
        TEdit *phone;
        TLabel *Label5;
        TEdit *gguin;
        TLabel *Label6;
        TLabel *Label7;
        TComboBox *status;
        void __fastcall FormCreate(TObject *Sender);
        void __fastcall Button3Click(TObject *Sender);
        void __fastcall Button2Click(TObject *Sender);
	void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
private:	// User declarations
public:		// User declarations
        AnsiString contacts_filename, friends_filename, foes_filename;
        TListItem *liEdited;	///< edytowany element listy
        __fastcall TContactForm(TComponent* Owner);
		void ReadContacts();
		void ReadContactsFromList(TStringList *S);
        void WriteContacts(AnsiString filename = "");
        void __fastcall ResetContactList();
};
//---------------------------------------------------------------------------
extern PACKAGE TContactForm *ContactForm;
//---------------------------------------------------------------------------
#endif
